package yrpg.slm.pc.common;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.entity.botp.runtime.ConvertOperationResult;
import kd.bos.entity.botp.runtime.PushArgs;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.operate.OperateOptionConst;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.servicehelper.botp.ConvertServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.util.ArrayList;
import java.util.List;

/**
 * @author rexing
 */
public class BillPushCommon {

    /**
     * 调用单据下推
     * @param sourceBill
     * @param targetBill
     * @param ids
     */
    public static void billPushAward(String sourceBill, String targetBill, List<Long> ids){
        Long orgId = RequestContext.get().getOrgId();
        //生成下推参数PushArgs
        PushArgs pushArgs = new PushArgs();
        //必选，源单标识
        pushArgs.setSourceEntityNumber(sourceBill);
        //必选，目标单标识
        pushArgs.setTargetEntityNumber(targetBill);
        //可选，传入true，不检查目标单新增权
        pushArgs.setHasRight(true);
        //可选，传入目标单验权使用的应用编码
        pushArgs.setAppId("");
        //可选，传入目标单主组织默认值
        //pushArgs.setDefOrgId(orgId);
        //可选，传入本次下推使用的转换规则id；传入空值，由系统自动寻找合适的转换规则
        pushArgs.setRuleId("");//单转换规则id
        //是否输出详细错误报告
        pushArgs.setBuildConvReport(true);
        //必选，设置需要下推的源单及分录内码
        // 设置需要下推的单据，或分录行
        List<ListSelectedRow> selectedRows = new ArrayList<>();
        for (Long id : ids) {
            ListSelectedRow srcBill = new ListSelectedRow(id);
            srcBill.setFormID(sourceBill);
            selectedRows.add(srcBill);
        }
        pushArgs.setSelectedRows(selectedRows);
        //调用下推引擎，下推目标单
        ConvertOperationResult pushResult= ConvertServiceHelper.pushAndSave(pushArgs);
        // 判断下推是否成功
        if (pushResult.isSuccess()) {
            //获取下推单据ids 并提交审核
            OperateOption subOption = OperateOption.create();
            OperateOption audOption = OperateOption.create();
            subOption.setVariableValue(OperateOptionConst.IGNOREWARN,String.valueOf(true));//不执行警告级别的校验器
            audOption.setVariableValue(OperateOptionConst.IGNOREWARN,String.valueOf(true));//不执行警告级别的校验器
            OperationResult subResult = OperationServiceHelper.executeOperate("submit",targetBill,pushResult.getTargetBillIds().toArray(),subOption);
            OperationResult audResult = OperationServiceHelper.executeOperate("audit",targetBill,pushResult.getTargetBillIds().toArray(),subOption);
        }
    }

}
