package yrpg.slm.pc.plugin.operate;

import kd.bos.algo.DataSet;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.EndOperationTransactionArgs;
import kd.bos.orm.ORM;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * 单据操作插件 奖项审核  根据当前奖项反写工资发放
 * @author renxing
 */
public class AwardDetailAuditOpPlugin extends AbstractOperationServicePlugIn implements Plugin {

    private DataSet awardTypeDataSet = null;//所有奖项
    private final String awardBill = "yrpg_pc_awardtype";//奖项

    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        e.getFieldKeys().add("yrpg_srcid");
        e.getFieldKeys().add("yrpg_totalamount");
    }
    @Override
    public void endOperationTransaction(EndOperationTransactionArgs e) {
        // TODO 奖项明细审核操作后加载修改上游的发放单
        List<DynamicObject> grantBillList = new ArrayList<>();
        //DynamicObjectCollection grantBillCollection = new DynamicObjectCollection();
        //获取所有的奖项id和发放标识
        this.getDataSet(awardBill);

        for (DynamicObject obj : e.getDataEntities()) {
            //获取当前单据的标识
            String billKey = obj.getDataEntityType().getName();
            if(!billKey.contains("grant")){//
                break;//只有发放奖项
            }
            BigDecimal sumTotalAmount = BigDecimal.ZERO;
            //源单标识
            String srcId = obj.getString("yrpg_srcid");
            //奖项金额
            BigDecimal totalAmount = obj.getBigDecimal("yrpg_totalamount");

            //加载工资发放单  获取源单分录并保存
            DynamicObject grantBill = BusinessDataServiceHelper.loadSingle(srcId, "yrpg_wages_grant");
            DynamicObjectCollection entryEntity = grantBill.getDynamicObjectCollection("yrpg_totalentryentity");//工资汇总
            DataSet nowAwardDataSet =  awardTypeDataSet.copy().filter("yrpg_grand = " + "'" +billKey+"'");//筛选当前标识的
            DynamicObjectCollection awardTypeCollection = ORM.create().toPlainDynamicObjectCollection(nowAwardDataSet.copy());
            //获取奖项的id
            long awardPkid = awardTypeCollection.stream().findFirst().get().getLong("id");
            //发放单奖项明细
            for(DynamicObject entry : entryEntity) {

                if(entry.getDynamicObject("yrpg_prize").getPkValue().equals(awardPkid)) {
                    sumTotalAmount = sumTotalAmount.add(totalAmount);
                    entry.set("yrpg_prizeprice1", totalAmount);//金额
                    break;
                }
            }
            grantBill.set("yrpg_totalamount",sumTotalAmount);//汇总金额

            grantBillList.add(grantBill);
            //grantBillCollection.add(grantBill);

        }

        if(grantBillList.size() == 0){
            return;
        }
        //保存反写的上游发放单
        OperationResult operationResult =
                SaveServiceHelper.saveOperate("yrpg_wages_grant", grantBillList.toArray(new DynamicObject[] {}),
                        OperateOption.create());
        if(operationResult.isSuccess()){

        }
        else{
            /**
             * 记录保存发放失败
             */
        }



    }

    /**
     * 获取所有奖项的数据
     * @param billMark
     */
    public void getDataSet(String billMark){
        awardTypeDataSet = QueryServiceHelper.queryDataSet(this.getClass().toString(), billMark,
                "id,yrpg_grand", null, null);

    }



}